Added support to replicate and restore from multiple backup pools
[zfs-ubuntu/.git] / zfs-replicate-all
index 44ca551544d780f61691d99aa065bf7b3734ec49..66949dfaa0c3a4b299dc79c0d4c14f3fa123c688 100755 (executable)
@@ -50,11 +50,15 @@ cleanup_and_exit() {
 }
 trap cleanup_and_exit INT
 
-fatal_and_exit() {
+fatal() {
   # echo message to terminal
   echo -e 2>&1 "$1"
   # send email notification
   echo -e "$1" | $mailx -s "zfs-replicate-all on $hostname failed" "$mailto"
+}
+
+fatal_and_exit() {
+  fatal $*
   exit 1
 }
 
@@ -85,6 +89,14 @@ snapshot_age() {
   fi
 }
 
+# Replicate every zfs filesystem specified in the config file
+echo "$date ZFS replicate started" >> $logfile
+echo "$date ZFS replicate started" | tee -a $mylogfile
+
+# Loop over each backup pool
+backup_pools=$backup_pool
+for backup_pool in $backup_pools; do
+
 # Import the local backup pool if needed and the option is given to do so, else error out
 zpool list -H "$backup_pool" >/dev/null 2>&1
 if [ $? != 0 ]; then
@@ -109,15 +121,20 @@ fi
 current_backup_marker=@current-backup-${backup_pool_guid}
 previous_backup_marker=@previous-backup-${backup_pool_guid}
 
-# Auto snapshot every zfs filesystem on the system specified below
-echo "$date ZFS replicate started" >> $logfile
-echo "$date ZFS replicate started" | tee -a $mylogfile
-
 # Sort the filesystems to replicate by the oldest backup first
 tmpfile=`tempfile`
 for filesystem in $filesystems_to_replicate; do
-  age=`snapshot_age $filesystem`
-  echo $filesystem $age >> $tmpfile
+  if [[ $filesystem =~ ':' ]]; then
+    dst_pool=${filesystem%%:*}
+    filesystem=${filesystem#*:} # remove src_pool from string
+  else
+    dst_pool=$backup_pool
+  fi
+  # Only backup filesystems that are specified to go this backup_pool
+  if [[ $backup_pool == $dst_pool ]]; then
+    age=`snapshot_age $filesystem`
+    echo $filesystem $age >> $tmpfile
+  fi
 done
 sorted_filesystems=`cat $tmpfile | sort -n -k 2 | awk '{ print $1 }'`
 rm -f $tmpfile
@@ -125,7 +142,7 @@ rm -f $tmpfile
 # Replicate the sorted filesystems
 for filesystem in $sorted_filesystems; do
   echo "-> Replicating $remote:$filesystem to ${backup_pool}/${filesystem}" | tee -a $mylogfile
-  replicate $remote $filesystem
+  replicate $remote $filesystem $backup_pool
 done
 
 # Export the local pool if told to do so
@@ -135,11 +152,14 @@ if [[ $import_export_backup_pool == 1 ]]; then
   if [ $? != 0 ]; then
     zpool export $backup_pool
     if [ $? != 0 ]; then
-      fatal_and_exit "-E- unable to export the local backup pool $backup_pool on $hostname" "$mailto"
+      lsof /$backup_pool/*
+      fatal "-E- unable to export the local backup pool $backup_pool on $hostname" "$mailto"
     fi
   fi
 fi
 
+done
+
 # All done
 echo `date` ZFS replicate complete >> $logfile
 echo `date` ZFS replicate complete | tee -a $mylogfile